#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ripimage.h"

struct imagehdr
{	BYTE image_tag[4];
    BYTE hi_image_len_lo;   // The Amiga was clearly of big-endian architecture
	BYTE hi_image_len_hi;
	BYTE lo_image_len_lo;
	BYTE lo_image_len_hi;
	BYTE unknown_tag[4];
};

main(int argc, char **argv)
{
	FILE *in;
	char ch, inf[80] = "data.mk3";
	struct imagehdr ih;

	printf("RipImage 1.1, 1995 hraiser@cloud9.net\n\n");

	if(argc >= 2) strncpy(inf, *++argv, sizeof(inf));

	if ((in = fopen(inf, "rb")) == NULL)
	{	printf("File not found, %s\n", inf);
		return 1;
	}

	while(!feof(in))
	{	fread(&ch, 1, 1, in);
		if(ch == 'F')
		{	fseek(in, -1, SEEK_CUR);
			fread(&ih, sizeof(ih), 1, in);
			if(!memcmp(ih.image_tag, "FORM", 4) &&
				!memcmp(ih.unknown_tag, "PBM ", 4))
			{
				fseek(in, (int)-(sizeof(ih)), SEEK_CUR);
				printf("Image found at offset %06X, ", ftell(in));
				ripimage(in);
			}
			else fseek(in, (int)-((sizeof(ih) - 1)), SEEK_CUR);
		}
	}
	return 0;
}

void ripimage(FILE *in)
{
	FILE *out;
	char fname[14];
	static unsigned count = 0;
	struct imagehdr ih;
	BYTE *buffer;
	DWORD image_len;

	fread(&ih, sizeof(ih), 1, in);
	image_len = MAKELONG(MAKEWORD(ih.lo_image_len_hi, ih.lo_image_len_lo),
		MAKEWORD(ih.hi_image_len_hi, ih.hi_image_len_lo));

	if((buffer = (BYTE *)malloc(image_len)) != NULL)
	{   sprintf(fname, "IMAGE%03d.LBM", count++);
		out = fopen(fname, "wb");
		printf("writing %s\n", fname);

		fread(buffer, image_len - 4, 1, in);
		fwrite(&ih, sizeof(ih), 1, out);
		fwrite(buffer, image_len - 4, 1, out);

		free(buffer);
		fclose(out);
	}
	else
	{	printf("\nError: Malloc() failed to allocate %lX bytes!\n",
			sizeof(ih) + image_len);
		fseek(in, image_len, SEEK_CUR);
	}
}
