#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "wave.h"

enum {FALSE, TRUE};

int ripwave(FILE *in, char *filename, struct riff_header *rh, int header_size, unsigned count);

main(int argc, char **argv)
{
	FILE *in;
	char buffer[4], ch, *p;
	unsigned count;
	unsigned char found_wave;
	struct riff_header rh;

	printf("RipWave 1.1 - 1995 hraiser@cloud9.net\n\n");

	if(argc < 2)
	{	printf("Args: RIPWAVE filespec [filespec] [...] (wildcards ok)\n");
		return 1;
	}

	while(--argc)
	{
		count = 0;
		found_wave = FALSE;

		if((in = fopen(*++argv, "rb")) == NULL)
		{	printf("File not found\n");
			return 1;
		}

		printf("Searching %s...\n", *argv);

		while(!feof(in))
		{
			fread(&ch, 1, 1, in);
			if(ch == 'R')
			{   fseek(in, -1, SEEK_CUR);
				if((fread(&rh, sizeof(rh), 1, in)) == 0)
					break;

				if((!memcmp(rh.wave_tag, "WAVE", 4)) &&
					(!memcmp(rh.data_tag, "data", 4)))
				{	fseek(in, (int) -sizeof(rh), SEEK_CUR);
					if(ripwave(in, ((p = strrchr(*argv, '\\')) == NULL) ? *argv : ++p,
							&rh, sizeof(rh), count))
					{	count++;
						found_wave = TRUE;
					}
				}
				else fseek(in, (int) -(sizeof(rh) - 1), SEEK_CUR);
			}
		}
		if(!found_wave) printf("No Wave headers found in file.\n");
		fclose(in);
	}
	return 0;
}

int ripwave(FILE *in, char *filename, struct riff_header *rh, int header_size, unsigned count)
{
	char infname[14], outfname[14];
	char *buffer, *p;
	long wavelength;
	FILE *out;

	printf("Wave found in file %s at offset %06X", filename, ftell(in));

	strcpy(infname, filename);
	if((p = strchr(infname, '.')) != NULL) *p = NULL;

	sprintf(outfname, "%.4s_%03d.WAV", infname, count);

	if((out = fopen(outfname, "wb")) == NULL)
	{	printf("\nError: Write failed!\n");
		fseek(in, header_size + rh->data_length, SEEK_CUR);
		return 0;
	}

	wavelength = header_size + rh->data_length;

	if((buffer = (char *)malloc(wavelength)) == NULL)
	{	printf("\nError: Failed to malloc() %lX (%ld) bytes, skipping.\n",
			rh->data_length, rh->data_length);
		fseek(in, header_size + rh->data_length, SEEK_CUR);
		fclose(out);
		return 0;
	}

	fread(buffer, wavelength, 1, in);

	printf(", writing %s\n", outfname);

	fwrite(buffer, wavelength, 1, out);

	fclose(out);
	free(buffer);
	return 1;
}